#include <acknex.h>
//MiniPH by Vadim647
TEXT* ents = {string("Sphere","Drop","Box","Plate","Cylinder","PlateC");}
//Text containing entlist (what you can create ingame)
VECTOR c_pos;		//camera base position
VECTOR t_v;			//temp vector
STRING* t_s="#64";	//temp string
STRING* t_s2="#64";	//one more ^
ENTITY* s_e;		//current entity, attached to mouse with offset
action* t_a;		//temp action, needed to make algoritm of entity creation using list
var mouse_t;		//cycling variable to make 'burst' variable changes
var entv = 0;		//primitive type number
var s_e_z;			//entity Z offset
BMAP* curmap = "cursor.tga";	//cursor
function mouse2level() {VECTOR vecFrom;VECTOR vecTo;		//easy function to get mouse pos in level
vec_set(vecFrom,vector(mouse_cursor.x,mouse_cursor.y,10));	//btw, using mouse_dir3d makes problems
vec_for_screen(vecFrom,camera);
vec_set(vecTo,vector(mouse_cursor.x,mouse_cursor.y,5000));
vec_for_screen(vecTo,camera);
return(c_trace(vecFrom,vecTo,IGNORE_PASSABLE|USE_POLYGON));}
function phent(mass,ph1,ph2,friction){	wait(1);						//easy way to shorten my code
										set(my,SHADOW|POLYGON);			//just a function-action for
										phent_settype(me,PH_RIGID,ph1);	//everything that gives standart
										phent_setmass(me,mass,ph2);		//phent_* parameters and some 
										phent_setelasticity(me,35,64);	//unique (mass,hulltype,friction)
										phent_setfriction(me,friction);
										phent_setmaxspeed(me,1024,180);
										while(!(is(my,FLAG1)))
										{if (my.z < 0) set(my,FLAG1);
										wait(1);}
										phent_settype(me,0,0);
										ent_remove(me);}
function sphere()	{	phent(3,PH_SPHERE,PH_SPHERE,90);		}	//some ent action that are using previos ^
function drop()		{	phent(0.25,PH_SPHERE,PH_SPHERE,5);		}
function box()		{	phent(3,PH_BOX,PH_BOX,90);				}
function cylinder()	{	phent(3,PH_BOX,PH_CYLINDER,90);	}
function dph_exit() {sys_exit("<.>");}
function dph_level() {set(my,SHADOW|POLYGON);}
function makeit()	//triggered if mouse_left every .../1 seconds
{
	str_cpy(t_s,(ents.pstring)[entv]);	//copy ent name from 'database'
	str_cpy(t_s2,t_s);					
	str_cat(t_s2,".mdl");				//add a '.mdl' label
	if (entv==0) t_a = sphere;			//entity's are sorted by action in list
	if (entv==1) t_a = drop;			//if you want to edit list, you'll need to edit this
	if (entv>=2&&entv<4) t_a = box;
	if (entv>=4&&entv<7) t_a = cylinder;
	you = ent_create(t_s2,s_e.x,t_a);	//now create specified entity
	vec_set(you.pan,s_e.pan);			//and rotate it
}
function main() {
	vec_set(sky_color,vector(120,110,100));	//background color
	shadow_stencil = 2;						//stencil shadows, because I have only models here
	level_load(NULL);						//empty level, makes sense under 7.08 (i think...)
	wait(2);								//below 7.06 this is un-avoidable
	ent_create("level1.mdl",nullvector,dph_level);	//create mdl level and make it cast shadows
	video_switch(8,0,1);							//1024x768 fullscreen
	vec_set(camera.pan,vector(120,-60,0));			//default camera angle
	on_esc = dph_exit;									//on escape exit game
	ph_setgravity(vector(0,0,-384));					//gravity present here, even if it would be more
	s_e = ent_create("sphere.mdl",vector(0,0,64),NULL);	//interesting without it
	set(s_e,PASSABLE|SHADOW);		//^ create placable entity
	mouse_map = curmap;				//set mouse cursor
	mouse_mode = 4;					//game cursor follows windows cursor
	draw_textmode("arial",1,20,75);	//draw_text mode: standart font with 75% alpha
	while (1)
	{
		mouse2level();				//find mouse position in level
		if (trace_hit) {reset(s_e,INVISIBLE);set(s_e,SHADOW);} else {set(s_e,INVISIBLE);reset(s_e,SHADOW);}
		//if not in level, make placable ent invisible
		vec_set(s_e.x,vector(target.x,target.y,target.z+s_e_z));	//set ent pos with Z offset
		s_e_z += mickey.z / 120 * 32;								//add Z offset
		mouse_t -= time_step;
		if (mouse_t <= 0 && key_any) {mouse_t = 3;		//now all the keyboard/mouse functions that can be done
			if (key_x) s_e_z += 32;
			if (key_z) s_e_z -= 32;
			if (mouse_left&&trace_hit) makeit();
			if (mouse_right&&you!=NULL) set(you,FLAG1); 
			if (key_z&&you!=NULL) you.frame = cycle(you.frame+time_step,0,ent_frames(you));
			if (key_r) entv = cycle(entv+1,0,ents.strings);
			if (key_f) entv = cycle(entv-1,0,ents.strings);
			if (key_r||key_f) 
			{
				str_cpy(t_s,(ents.pstring)[entv]);
				str_cat(t_s,".mdl");
				ent_morph(s_e,t_s);
			}
			if (key_w) s_e.tilt = ang(s_e.tilt + 15);
			if (key_s) s_e.tilt = ang(s_e.tilt - 15);
			if (key_a) s_e.pan = ang(s_e.pan - 15);
			if (key_d) s_e.pan = ang(s_e.pan + 15);
			if (key_e) s_e.roll += 15;
			if (key_q) s_e.roll -= 15;
			if (key_i) camera.tilt = clamp(camera.tilt - 15,-90,0);
			if (key_k) camera.tilt = clamp(camera.tilt + 15,-90,0);
			if (key_j) camera.pan -= 15;
			if (key_l) camera.pan += 15;
			if (key_u) c_pos.z -= 32;
			if (key_o) c_pos.z += 32;
		}
		str_cpy(t_s,(ents.pstring)[entv]);
		str_cat_num(t_s,"\nPan: %.0f",s_e.pan);
		str_cat_num(t_s,"\nTilt: %.0f",s_e.tilt);
		str_cat_num(t_s,"\nRoll: %.0f",s_e.roll);
		draw_text(t_s,4,4,vector(224,224,224));
		draw_text("Created by Vadim647",4,744-32,vector(224,224,224));
		if (total_secs < 30) draw_text("Quick Help:
		A|D,W|S,Q|E - adjust pan/tilt/roll
		R|F - change primitive type
		J|L,I|K - change camera angle
		U|O - change camera z
		mouseLeft - create primitive
		mouseRight - erase primitive
		mouseWheel,Z|X - change z offset",768,16,vector(224,224,224));
		vec_add(c_pos.x,vector(time_step*(cosv(camera.pan)*key_force.y-cosv(camera.pan+90)*key_force.x)*10,
		time_step*(sinv(camera.pan)*key_force.y-sinv(camera.pan+90)*key_force.x)*10,0));
		vec_set(camera.x,vector(
		c_pos.x + cosv(camera.pan) * -512 * cosv(camera.tilt),
		c_pos.y + sinv(camera.pan) * -512 * cosv(camera.tilt),
		c_pos.z + sinv(camera.tilt) * -512
		));
		wait(1);
	}
}